/////////////////////////////////////////////////////////////////////////////
//Doppelpendel ohne Reibung und ohne Schwerkraft mit Runge-Kutta 4 
//Phasendiagramm beider Pendel 
//Periodische Schwingung
/////////////////////////////////////////////////////////////////////////////

// Attribute:
int n = 4;            // Anzahl der Variablen
float[] ZVaktuell = {3.14, 3.14, 0, 0}; // Initialisierung w1,w2,g1,g2
float w1,w2; //Winkel von der Senkrechten weg
float W1,W2; //Für Runge-Kutta verwendet: Winkel in Ruhelage: PI
float g1,g2; //Winkelgeschwindigkeiten
float xAchse;      
float dt = 0.1;      // Zeitschritt
//Lage der Massen
float masse1X ;
float masse1Y ;
float masse2X ;
float masse2Y ;
float masse;
float L = 180;
float G = 0;         // Ortfaktor für Schwerkraft
float ruhelage = 400;         // Ruhelag in x-Koordinate
float EKontrolleA;//Gesamtenergie 
float wK,gK; //Koordinaten der Bildpunkte
float D1,D2; //Diskriminaten für die Berechnung der fehlenden Winkelgeschwindigkeit bei gleicher Energie
color farbe1,farbe2;
int M,m, AnzahlStartpunkte;
float wVor,wNach;
ArrayList<PVector> punkte1 = new ArrayList<PVector>(); //Oberes Pendel
ArrayList<PVector> punkte2 = new ArrayList<PVector>(); //Unteres Pendel
///////////////////////////////////////////////////////////////////////////
void setup() {
  size(800,800);
  background(0);
  masse =1;
  farbe1 = color(255,0,0);
  farbe2 = color(0,255,0);
  M = 30000;//Anzahl Folge-Punkte für einen Anfangspunkt
  AnzahlStartpunkte = 1;
  D1=D2=0;
  neuStarten();
 // EKontrolleA = masse*g1*g1*L*L +0.5*masse*g2*g2*L*L + masse*g1*g2*L*L*cos(w2-w1) - G*masse*L*(2*cos(w1)+cos(w2)-3);
  for(int j = 0; j<AnzahlStartpunkte;j++){
    folgePunkteBerechnen(); 
  }
}

/////////////////////////////////////////////////////////
void draw() { 
 
  
}
//////////////////////////////////////////////////////////
float[] ZVentwickeln(float[] Y) {
    float[] ZustandsVektor = new float[n]; 
    ZustandsVektor[0]=Y[2];
    ZustandsVektor[1]=Y[3];
    // benötigte Werte :
    float sinDiff = sin(Y[0]-Y[1]);
    float cosDiff = cos(Y[0]-Y[1]);
    float cosProdukt = cosDiff * cosDiff;
    float s0 = sin(Y[0]);
    float s1 = sin(Y[1]);
    float alpha = - Y[3]*Y[3]*sinDiff + 2*G/L*s0 ;
    float beta = Y[2]*Y[2]*sinDiff + G/L*s1 ;
    ZustandsVektor[2]= 1 / (2-cosProdukt) * (alpha - cosDiff * beta); //Geschwindigkeit 1
    ZustandsVektor[3]= 1 / (2-cosProdukt) * (2*beta - cosDiff * alpha);//Geschwindigkeit 2 
    return ZustandsVektor;
}
////////////////////////////////////////////////////////////////////////////
void pendelUpdate(){
    // Zustand nach nächstem Zeitschritt mit Runge-Kutta 4 berechnen
    // "float[] ZVaktuell" Methode der zeitlichen Ableitung dy/dt (4-dimensional). 
    
    float[] K1 = ZVentwickeln(ZVaktuell); 
    // K2 =ZustandsVektor(t0 + dt/2, ZVaktuell + dt/2 * K1)
    float[] ZVtemp = new float[n];
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K1[i]*dt*0.5;    
    }
    float[] K2 = ZVentwickeln(ZVtemp);
    // K3 =ZustandsVektor(t0 + dt/2, ZVaktuell + dt/2 * K2)
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K2[i]*dt*0.5;
    }
    float[] K3 = ZVentwickeln(ZVtemp);
    // K4 =ZustandsVektor(t0 + dt, ZVaktuell + dt * K3)
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K3[i]*dt;
    }
    float[] K4 = ZVentwickeln(ZVtemp);
    // Zusammenfassung
    //  ZVaktuell = ZVaktuell + dt/6 * (K1 + 2*(K2+K3) + K4)
    for (int i=0; i<n; i++) {
      ZVaktuell[i] = ZVaktuell[i] + dt / 6.0 * (K1[i] + 2.0*(K2[i] + K3[i]) + K4[i]);
    }  
  
     wK = map(ZVaktuell[0],0,2*PI,0,800);  //Koordinaten der Poincaré-Schnitt Punkte 
     gK = map(ZVaktuell[2],-0.1, 0.3,800,0);   
     punkte1.add(new PVector(wK,gK));
     wK = map(ZVaktuell[1],0,2*PI,0,800);  //Koordinaten der Poincaré-Schnitt Punkte 
     gK = map(ZVaktuell[3],-0.1, 0.3,800,0);   
     punkte2.add(new PVector(wK,gK));
     xAchse = map(0,-0.1, 0.3,800,0);   
     stroke(255);
     line(0,xAchse,800,xAchse);//markiert die Winkelgeschwindigkeit Null
     m++; 
       
     
    //Winkel immer zwischen 0 und 2*PI 
    if(ZVaktuell[0] > 2*PI) ZVaktuell[0] = ZVaktuell[0] - 2*PI;
    if(ZVaktuell[0] < 0)    ZVaktuell[0] = ZVaktuell[0] + 2*PI;
    if(ZVaktuell[1] > 2*PI) ZVaktuell[1] = ZVaktuell[1] - 2*PI;
    if(ZVaktuell[1] < 0)    ZVaktuell[1] = ZVaktuell[1] + 2*PI;
    W1 = ZVaktuell[0]; w1 = PI-W1;
    W2 = ZVaktuell[1]; w2 = PI-W2;
    g1= ZVaktuell[2];
    g2 = ZVaktuell[3]; 
}

///////////////////////////////////////////////////////////////////
  
void folgePunkteBerechnen(){
  while(m<M){
      pendelUpdate();
    }
   punkteZeichnen();
}
  
////////////////////////////////////////////////////////////////////////////////
void mouseClicked() {//Neustart abwechselnd mit und ohne Spur
  background(0);
  neuStarten();
 // farbe = color(random(256),random(256),random(256));
  for(int j = 0; j<AnzahlStartpunkte;j++){
    folgePunkteBerechnen(); 
  }
}
////////////////////////////////////////////////////////////////////////////////
void keyPressed() {//Animation schneller/langsamer
  if (key == '+') {
    dt = dt*1.2;
  }
  if (key == '-') {
    dt = dt/1.2;
  }
}
///////////////////////////////////////////////////////////////////////////////
void neuStarten(){
  
 w1=0.2450284;
  W1 = PI-w1;
  w2= -0.14059933;
  W2 = PI-w2;
  g1=-0.08737184; 
  g2=0.17479349; 
  
  EKontrolleA = masse*g1*g1*L*L +0.5*masse*g2*g2*L*L + masse*g1*g2*L*L*cos(w2-w1) ;
  println(EKontrolleA);
  println(w1,w2,g1,g2);
 
  
  ZVaktuell[0] = W1;
  ZVaktuell[1] = W2;         
  ZVaktuell[2] = g1;
  ZVaktuell[3] = g2; 

  m = 0;
 
 
}  
//////////////////////////////////////////////////////////////////////////////
void punkteZeichnen(){  
    stroke(farbe1);
    strokeWeight(1);
    for(int i =0; i< punkte1.size()-1 ;i++){       
        point(punkte1.get(i).x,punkte1.get(i).y);      
      }
    punkte1.clear();
    
     stroke(farbe2);
    strokeWeight(1);
    for(int i =0; i< punkte2.size()-1 ;i++){       
        point(punkte2.get(i).x,punkte2.get(i).y);      
      }
    punkte2.clear();
}
